% Created 2019-05-06 ma 14:29
% Intended LaTeX compiler: xelatex
\documentclass[a4paper, 11pt]{article}
    \input{/home/bram/.dotfiles/latex/agda.tex}
\usepackage{graphicx}
\usepackage{grffile}
\usepackage{longtable}
\usepackage{wrapfig}
\usepackage{rotating}
\usepackage[normalem]{ulem}
\usepackage{amsmath}
\usepackage{textcomp}
\usepackage{amssymb}
\usepackage{capt-of}
\usepackage{hyperref}
\usetag{tutorial,note}
\newunicodechar{⟪}{\guillemotleft}
\newunicodechar{⟫}{\guillemotright}
\newunicodechar{⊗}{\ensuremath{\otimes}}
\newunicodechar{⟨}{\ensuremath{\langle}}
\newunicodechar{⟩}{\ensuremath{\rangle}}
\newunicodechar{◇}{\ensuremath{\Diamond}}
\newunicodechar{□}{\ensuremath{\Box}}
\author{Bram van den Boomen}
\date{\today}
\title{SequentProof Module}
\hypersetup{
 pdfauthor={Bram van den Boomen},
 pdftitle={SequentProof Module},
 pdfkeywords={},
 pdfsubject={},
 pdfcreator={Emacs 26.2 (Org mode 9.1.9)}, 
 pdflang={English}}
\usepackage[conor]{agda}

\begin{document}

\maketitle

\section{Preface}
\label{sec:orgb7c87e6}
\emph{Version: Main \tagged{tutorial}{+ Tutorial} \tagged{note}{+ Notes}}

\begin{code}
open import Agda.Builtin.Equality using (_≡_; refl)

module SequentProof where

open import Logic
\end{code}

\section{NL}
\label{sec:org6d96dcb}

\begin{code}
infix 4 NLs_ Ls_ LPs_ SCs_
infix 5 _⇒_
data Sequent : Set where
  _⇒_ : Struct → Type → Sequent
\end{code}

\subsection{Logical Rules}
\label{sec:org7a017dd}
\newcommand{\bs}{\backslash}
\newcommand{\fs}{/}
\renewcommand{\to}{\Rightarrow}

\[\addtolength{\inferLineSkip}{1pt}
\infer[Ax]{A \to A}{}
\]
\[\addtolength{\inferLineSkip}{1pt}
\infer[\bs L]{X[Y \cdot (A \bs B)] \to C}{Y \to A & X[B] \to C}
\qquad
\infer[\bs R]{X \to A \bs B}{A \cdot X \to B}
\]
\[\addtolength{\inferLineSkip}{1pt}
\infer[\fs L]{X[(B \fs A) \cdot Y] \to C}{Y \to A & X[B] \to C}
\qquad
\infer[\fs R]{X \to B \fs A}{X \cdot A \to B}
\]
\[\addtolength{\inferLineSkip}{1pt}
\infer[\otimes L]{X[A \otimes B] \to C}{X[A \cdot B] \to C}
\qquad
\infer[\otimes R]{X \cdot Y \to A \otimes B}{X \to A & Y \to B}
\]

\subsection{Agda Rules}
\label{sec:org2edc9e7}
\begin{code}
data NLs_ : Sequent → Set where
  ax : (A : Struct) → NLs A ⇒ [ A ]ᵀ
  ⟫L : ∀ {A B C   Y}{X[B] X[Y∙A⟫B]}
    {s1 : ⌈ B ⌉ ∈s X[B]}
    {s2 : (Y ∙ ⌈ A ⟫ B ⌉) ∈s X[Y∙A⟫B]}
    (s3 : ((X[B] ─ ⌈ B ⌉) s1) ≡ ((X[Y∙A⟫B] ─ (Y ∙ ⌈ A ⟫ B ⌉)) s2))
      → NLs Y ⇒ A → NLs X[B] ⇒ C → NLs X[Y∙A⟫B] ⇒ C
  ⟫R : ∀ {A B   X  } → NLs ⌈ A ⌉ ∙ X ⇒ B → NLs X ⇒ A ⟫ B
  ⟪L : ∀ {A B C   Y}{X[B] X[B⟪A∙Y]}
    {s1 : ⌈ B ⌉ ∈s X[B]}
    {s2 : (⌈ A ⟪ B ⌉ ∙ Y) ∈s X[B⟪A∙Y]}
    (s3 : ((X[B] ─ ⌈ B ⌉) s1) ≡ ((X[B⟪A∙Y] ─ (⌈ A ⟪ B ⌉ ∙ Y)) s2))
      → NLs Y ⇒ A → NLs X[B] ⇒ C → NLs X[B⟪A∙Y] ⇒ C
  ⟪R : ∀ {A B   X  } → NLs X ∙ ⌈ A ⌉ ⇒ B → NLs X ⇒ B ⟪ A
  ⊗L : ∀ {A B C    }{X[A∙B] X[A⊗B]}
    {s1 : (⌈ A ⌉ ∙ ⌈ B ⌉) ∈s X[A∙B]}
    {s2 : ⌈ A ⊗ B ⌉ ∈s X[A⊗B]}
    (s3 : ((X[A∙B] ─ (⌈ A ⌉ ∙ ⌈ B ⌉)) s1) ≡ ((X[A⊗B] ─ ⌈ A ⊗ B ⌉) s2))
      → NLs X[A∙B] ⇒ C → NLs X[A⊗B] ⇒ C
  ⊗R : ∀ {A B   X Y} → NLs X ⇒ A → NLs Y ⇒ B → NLs X ∙ Y ⇒ A ⊗ B
\end{code}

\section{L (associativity)}
\label{sec:org6981275}

\subsection{Logical Rules}
\label{sec:org5acc3a4}
\textbf{L}=\textbf{NL}+ass$^{l}$,ass$^{r}$

\[\addtolength{\inferLineSkip}{1pt}
\infer[\texttt{ass}^l]{X[(Y\cdot Z)\cdot W] \to D}{X[Y \cdot (Z \cdot W)] \to D}
\qquad
\infer[\texttt{ass}^r]{X[Y\cdot (Z\cdot W)] \to D}{X[(Y \cdot Z) \cdot W] \to D}
\]

\subsection{Agda Rules}
\label{sec:orgb84462e}
\begin{code}
data Ls_ : Sequent → Set where
  ax : (A : Struct) → Ls A ⇒ [ A ]ᵀ
  ⟫L : ∀ {A B C   Y}{X[B] X[Y∙A⟫B]}
    {s1 : ⌈ B ⌉ ∈s X[B]}
    {s2 : (Y ∙ ⌈ A ⟫ B ⌉) ∈s X[Y∙A⟫B]}
    (s3 : ((X[B] ─ ⌈ B ⌉) s1) ≡ ((X[Y∙A⟫B] ─ (Y ∙ ⌈ A ⟫ B ⌉)) s2))
      → Ls Y ⇒ A → Ls X[B] ⇒ C → Ls X[Y∙A⟫B] ⇒ C
  ⟫R : ∀ {A B   X  } → Ls ⌈ A ⌉ ∙ X ⇒ B → Ls X ⇒ A ⟫ B
  ⟪L : ∀ {A B C   Y}{X[B] X[B⟪A∙Y]}
    {s1 : ⌈ B ⌉ ∈s X[B]}
    {s2 : (⌈ A ⟪ B ⌉ ∙ Y) ∈s X[B⟪A∙Y]}
    (s3 : ((X[B] ─ ⌈ B ⌉) s1) ≡ ((X[B⟪A∙Y] ─ (⌈ A ⟪ B ⌉ ∙ Y)) s2))
      → Ls Y ⇒ A → Ls X[B] ⇒ C → Ls X[B⟪A∙Y] ⇒ C
  ⟪R : ∀ {A B   X  } → Ls X ∙ ⌈ A ⌉ ⇒ B → Ls X ⇒ B ⟪ A
  ⊗L : ∀ {A B C    }{X[A∙B] X[A⊗B]}
    {s1 : (⌈ A ⌉ ∙ ⌈ B ⌉) ∈s X[A∙B]}
    {s2 : ⌈ A ⊗ B ⌉ ∈s X[A⊗B]}
    (s3 : ((X[A∙B] ─ (⌈ A ⌉ ∙ ⌈ B ⌉)) s1) ≡ ((X[A⊗B] ─ ⌈ A ⊗ B ⌉) s2))
      → Ls X[A∙B] ⇒ C → Ls X[A⊗B] ⇒ C
  ⊗R : ∀ {A B   X Y} → Ls X ⇒ A → Ls Y ⇒ B → Ls X ∙ Y ⇒ A ⊗ B

  assᵣ : ∀ {Y Z W D XR XL}
    {s1 : (Y ∙ ( Z ∙ W)) ∈s XR}
    {s2 : ((Y ∙ Z) ∙ W) ∈s XL}
    (s3 : ((XR ─ (Y ∙ (Z ∙ W))) s1) ≡ ((XL ─ ((Y ∙ Z) ∙ W)) s2))
      → Ls XL ⇒ D → Ls XR ⇒ D
  assₗ : ∀ {Y Z W D XR XL}
    {s2 : ((Y ∙ Z) ∙ W) ∈s XL}
    {s1 : (Y ∙ ( Z ∙ W)) ∈s XR}
    (s3 : ((XR ─ (Y ∙ (Z ∙ W))) s1) ≡ ((XL ─ ((Y ∙ Z) ∙ W)) s2))
      → Ls XR ⇒ D → Ls XL ⇒ D
\end{code}

\section{LP (commutativity)}
\label{sec:orgba1b7c3}

\subsection{Logical Rules}
\label{sec:org843615e}
\textbf{LP}=\textbf{L}+comm

\[
\infer[\texttt{comm}]{X[Y\cdot Z] \to C}{X[Z\cdot Y] \to C}
\]

\subsection{Agda Rules}
\label{sec:org1d003ed}
\begin{code}
data LPs_ : Sequent → Set where
  ax : (A : Struct) → LPs A ⇒ [ A ]ᵀ
  ⟫L : ∀ {A B C   Y}{X[B] X[Y∙A⟫B]}
    {s1 : ⌈ B ⌉ ∈s X[B]}
    {s2 : (Y ∙ ⌈ A ⟫ B ⌉) ∈s X[Y∙A⟫B]}
    (s3 : ((X[B] ─ ⌈ B ⌉) s1) ≡ ((X[Y∙A⟫B] ─ (Y ∙ ⌈ A ⟫ B ⌉)) s2))
      → LPs Y ⇒ A → LPs X[B] ⇒ C → LPs X[Y∙A⟫B] ⇒ C
  ⟫R : ∀ {A B   X  } → LPs ⌈ A ⌉ ∙ X ⇒ B → LPs X ⇒ A ⟫ B
  ⟪L : ∀ {A B C   Y}{X[B] X[B⟪A∙Y]}
    {s1 : ⌈ B ⌉ ∈s X[B]}
    {s2 : (⌈ A ⟪ B ⌉ ∙ Y) ∈s X[B⟪A∙Y]}
    (s3 : ((X[B] ─ ⌈ B ⌉) s1) ≡ ((X[B⟪A∙Y] ─ (⌈ A ⟪ B ⌉ ∙ Y)) s2))
      → LPs Y ⇒ A → LPs X[B] ⇒ C → LPs X[B⟪A∙Y] ⇒ C
  ⟪R : ∀ {A B   X  } → LPs X ∙ ⌈ A ⌉ ⇒ B → LPs X ⇒ B ⟪ A
  ⊗L : ∀ {A B C    }{X[A∙B] X[A⊗B]}
    {s1 : (⌈ A ⌉ ∙ ⌈ B ⌉) ∈s X[A∙B]}
    {s2 : ⌈ A ⊗ B ⌉ ∈s X[A⊗B]}
    (s3 : ((X[A∙B] ─ (⌈ A ⌉ ∙ ⌈ B ⌉)) s1) ≡ ((X[A⊗B] ─ ⌈ A ⊗ B ⌉) s2))
      → LPs X[A∙B] ⇒ C → LPs X[A⊗B] ⇒ C
  ⊗R : ∀ {A B   X Y} → LPs X ⇒ A → LPs Y ⇒ B → LPs X ∙ Y ⇒ A ⊗ B

  assᵣ : ∀ {Y Z W D XR XL}
    {s1 : (Y ∙ ( Z ∙ W)) ∈s XR}
    {s2 : ((Y ∙ Z) ∙ W) ∈s XL}
    (s3 : ((XR ─ (Y ∙ (Z ∙ W))) s1) ≡ ((XL ─ ((Y ∙ Z) ∙ W)) s2))
      → LPs XL ⇒ D → LPs XR ⇒ D
  assₗ : ∀ {Y Z W D XR XL}
    {s2 : ((Y ∙ Z) ∙ W) ∈s XL}
    {s1 : (Y ∙ ( Z ∙ W)) ∈s XR}
    (s3 : ((XR ─ (Y ∙ (Z ∙ W))) s1) ≡ ((XL ─ ((Y ∙ Z) ∙ W)) s2))
      → LPs XR ⇒ D → LPs XL ⇒ D

  comm : ∀ {Y Z C}{X₁ X₂}
    {s1 : (Z ∙ Y) ∈s X₁}
    {s2 : (Y ∙ Z) ∈s X₂}
    (s3 : ((X₁ ─ (Z ∙ Y)) s1) ≡ ((X₂ ─ (Y ∙ Z)) s2))
      → LPs X₁ ⇒ C → LPs X₂ ⇒ C
\end{code}

\section{SC (structural control)}
\label{sec:orgdc847d7}

\subsection{Logical Rules}
\label{sec:org4c003c3}
\textbf{SC}=\textbf{NL}+\(\Diamond E,\Diamond I,\Box E,\Box I,R1,R2\)

\[\addtolength{\inferLineSkip}{1pt}
\infer[\Box L]{X[\langle \Box A \rangle] \to B}{X[A] \to B}
\qquad
\infer[\Box R]{X \to \Box A}{\langle X \rangle \to A}
\]
\[\addtolength{\inferLineSkip}{1pt}
\infer[\Diamond L]{X[\Diamond A] \to B}{X[\langle A \rangle] \to B}
\qquad
\infer[\Diamond R]{\langle X \rangle \to \Diamond A}{X \to A}
\]

\[\addtolength{\inferLineSkip}{1pt}
\infer[R1]{X[W \cdot (Y \cdot \langle Z \rangle)] \to A}{X[(W \cdot Y) \cdot \langle Z \rangle] \to A}
\qquad
\infer[R1']{X[(\langle W \rangle \cdot Y) \cdot Z] \to A}{X[\langle W \rangle \cdot (Y \cdot Z)] \to A}
\]
\[\addtolength{\inferLineSkip}{1pt}
\infer[R2]{X[(W \cdot Y) \cdot \langle Z \rangle] \to A}{X[(W \cdot \langle Z \rangle) \cdot Y] \to A}
\qquad
\infer[R2']{X[\langle W \rangle \cdot (Y \cdot Z)] \to A}{X[Y \cdot (\langle W \rangle \cdot Z)] \to A}
\]

\subsection{Agda rules}
\label{sec:orgdff4ced}
\begin{code}
data SCs_ : Sequent → Set where
  ax : (A : Struct) → SCs A ⇒ [ A ]ᵀ
  □L : ∀ {A B}{X[A] X[⟨□A⟩]}
    {s1 : ⌈ A ⌉ ∈s X[A]}
    {s2 : ⟨ ⌈ □ A ⌉ ⟩ ∈s X[⟨□A⟩]}
    (s3 : ((X[A] ─ ⌈ A ⌉) s1) ≡ ((X[⟨□A⟩] ─ ⟨ ⌈ □ A ⌉ ⟩) s2))
      → SCs X[A] ⇒ B → SCs X[⟨□A⟩] ⇒ B
  □R : ∀ {A X} → SCs ⟨ X ⟩ ⇒ A → SCs X ⇒ □ A
  ◇L : ∀ {A B}{X[◇A] X[⟨A⟩]}
    {s1 : ⌈ ◇ A ⌉ ∈s X[◇A]}
    {s2 : ⟨ ⌈ A ⌉ ⟩ ∈s X[⟨A⟩]}
    (s3 : ((X[◇A] ─ ⌈ ◇ A ⌉) s1) ≡ ((X[⟨A⟩] ─ ⟨ ⌈ A ⌉ ⟩) s2))
      → SCs X[⟨A⟩] ⇒ B → SCs X[◇A] ⇒ B
  ◇R : ∀ {A X} → SCs X ⇒ A → SCs ⟨ X ⟩ ⇒ ◇ A
  ⟫L : ∀ {A B C   Y}{X[B] X[Y∙A⟫B]}
    {s1 : ⌈ B ⌉ ∈s X[B]}
    {s2 : (Y ∙ ⌈ A ⟫ B ⌉) ∈s X[Y∙A⟫B]}
    (s3 : ((X[B] ─ ⌈ B ⌉) s1) ≡ ((X[Y∙A⟫B] ─ (Y ∙ ⌈ A ⟫ B ⌉)) s2))
      → SCs Y ⇒ A → SCs X[B] ⇒ C → SCs X[Y∙A⟫B] ⇒ C
  ⟫R : ∀ {A B   X  } → SCs ⌈ A ⌉ ∙ X ⇒ B → SCs X ⇒ A ⟫ B
  ⟪L : ∀ {A B C   Y}{X[B] X[B⟪A∙Y]}
    {s1 : ⌈ B ⌉ ∈s X[B]}
    {s2 : (⌈ A ⟪ B ⌉ ∙ Y) ∈s X[B⟪A∙Y]}
    (s3 : ((X[B] ─ ⌈ B ⌉) s1) ≡ ((X[B⟪A∙Y] ─ (⌈ A ⟪ B ⌉ ∙ Y)) s2))
      → SCs Y ⇒ A → SCs X[B] ⇒ C → SCs X[B⟪A∙Y] ⇒ C
  ⟪R : ∀ {A B   X  } → SCs X ∙ ⌈ A ⌉ ⇒ B → SCs X ⇒ B ⟪ A
  ⊗L : ∀ {A B C    }{X[A∙B] X[A⊗B]}
    {s1 : (⌈ A ⌉ ∙ ⌈ B ⌉) ∈s X[A∙B]}
    {s2 : ⌈ A ⊗ B ⌉ ∈s X[A⊗B]}
    (s3 : ((X[A∙B] ─ (⌈ A ⌉ ∙ ⌈ B ⌉)) s1) ≡ ((X[A⊗B] ─ ⌈ A ⊗ B ⌉) s2))
      → SCs X[A∙B] ⇒ C → SCs X[A⊗B] ⇒ C
  ⊗R : ∀ {A B   X Y} → SCs X ⇒ A → SCs Y ⇒ B → SCs X ∙ Y ⇒ A ⊗ B

  R1  : ∀ {A W Y Z XL XR}
     {s1 : (W ∙ (Y ∙ ⟨ Z ⟩)) ∈s XR}
     {s2 : ((W ∙ Y) ∙ ⟨ Z ⟩) ∈s XL}
     (s3 : ((XR ─ (W ∙ (Y ∙ ⟨ Z ⟩))) s1) ≡ ((XL ─ ((W ∙ Y) ∙ ⟨ Z ⟩)) s2))
       → SCs XR ⇒ A → SCs XL ⇒ A
  R1` : ∀ {A W Y Z XL XR}
     {s1 : (⟨ W ⟩ ∙ (Y ∙ Z)) ∈s XR}
     {s2 : ((⟨ W ⟩ ∙ Y) ∙ Z) ∈s XL}
     (s3 : ((XR ─ (⟨ W ⟩ ∙ (Y ∙ Z))) s1) ≡ ((XL ─ ((⟨ W ⟩ ∙ Y) ∙ Z)) s2))
       → SCs XL ⇒ A → SCs XR ⇒ A
  R2  : ∀ {A W Y Z XL XR}
     {s1 : (W ∙ (Y ∙ ⟨ Z ⟩)) ∈s XR}
     {s2 : ((W ∙ ⟨ Z ⟩) ∙ Y) ∈s XL}
     (s3 : ((XR ─ (W ∙ (Y ∙ ⟨ Z ⟩))) s1) ≡ ((XL ─ ((W ∙ ⟨ Z ⟩) ∙ Y)) s2))
       → SCs XL ⇒ A → SCs XR ⇒ A
  R2` : ∀ {A W Y Z XL XR}
     {s1 : (⟨ W ⟩ ∙ (Y ∙ Z)) ∈s XR}
     {s2 : ((Y ∙ ⟨ W ⟩) ∙ Z) ∈s XL}
     (s3 : ((XR ─ (⟨ W ⟩ ∙ (Y ∙ Z))) s1) ≡ ((XL ─ ((Y ∙ ⟨ W ⟩) ∙ Z)) s2))
       → SCs XL ⇒ A → SCs XR ⇒ A
\end{code}
\end{document}